;
;****************************************************************
;		RSMPL						*
;****************************************************************
;
;	AUTEURS:		J. LAROCHE, JM. JOT
;	DATE DE MISE A JOUR:	06/06/91
;
;	OBJET DU MODULE: 	changement de Fe ( multipliee par P/Q )
;	Temps d'execution:
;
;	MEMOIRE X=Y:SON pointee par R0 (DIGITEC):
;	 L'echantillon d'entree X(n) est lu en memoire son.
;	 la sortie Y(n)= Sommme( X(n-i).H(i) ) pour i=0..Ordre
;	 est rangee  l'adresse suivante en memoire son.
;	*X=Y********* 
;   R0->*    X(n)   *	 entree (voie gauche en stereo)
;	*  [Xd(n)]  *	        (voie gauche en stereo)
;	*    Y(n)   *	 sortie (voie gauche en stereo)
;	*  [Yd(n)]  *	        (voie droite en stereo)
;	*************->R0
;
;	MEMOIRE X,Y:INTERNE pointee par R2 et R5
;	 X(n) est range dans dans un buffer circulaire en memoire interne
;	 pointee par R5 qui s'incremente a chaque periode d'echantillonnage modulo M5.
;	 Les echantillons d'entree precedents sont relus dans ce buffer
;	 pointes par R2, modulo M2.
;	***********X*Y***********
;	*           *           * debut du buffer circulaire
;	:           :           :
;       *   X(n-i)  * [Xd(n-i)] * <-R2 (pointeur de lecture des echantillons passes)
;	:           :           :
;       *   X(n-1)  * [Xd(n-1)] *
;   R5->*   X(n)    * [Xd(n)]   *
;	*           *           *->R5  (pointeur d'ecriture)
;	:           :           :
;	*           *           *
;	************************* fin du buffer circulaire
;
;	MEMOIRE X=Y:PARAMETRE pointee par R4
;   R4->*X=Y***********
;	*     P	      *
;	*     Q	      *
;	*    K-1      *
;	*    K.P      *
;       *    H(0)     *
;	*  [Hd(0)]    *
;	*    H(1)     *
;	*  [Hd(1)]    *
;	:             :
;	*   H(Ordre)  *
;	* [Hd(Ordre)] *			Ordre= K.P-1
;	***************->R4
;


	include	"next.asm"


	INIT_I				; Initialise les interruptions.

;; Debut de programme

	org	p:100	

start
	IRSMPL				; Initialise la routine.
	READPAR				; Lit les parametres (filtre etc...)
		
main
	bset	#m_stie,x:m_crb		;SSI Transmit interrupt enable
	
_main_loop				; Here's the main loop!!

	RSMPL				; Macro qui fait tout!
	
	jmp	_main_loop		; until the cows come home.

reset
	movep   #cra_init,x:m_cra   	;     Program up SSI port, as 
	movep   #crb_init,x:m_crb   	;     documented above.

	movec   #6,omr			;data rom enabled, mode 2
	bset    #0,x:m_pbc		;host port
	bset	#3,x:m_pcddr		;   pc3 is an output with value
	bclr	#3,x:m_pcd		;   zero to enable the external ram
	movep   #>$000000,x:m_bcr	;no wait states on the external sram
        movep   #>$00B400,x:m_ipr  	;intr levels: SSI=2, SCI=1, HOST=0
	move	#0,sr			;enable interrupts
	bset    #m_hcie,x:m_hcr		;host command interrupts

	movep   #pcd_init,x:m_pcd   	;   
	movep   #pcddr,x:m_pcddr	;  
	movep   #pcc,x:m_pcc        	;

	movep	#$0302,x:m_scr		; Configure SCI Control Register
	movep	#$1010,x:m_sccr
	jmp start
	
	DMA_IN				; subroutines for DMA_IN

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
	
sendsci
	move	#$1000,b1
		.loop	b1
			nop
			nop		; delay a while
			nop
			nop
		.endl
_waitSCIFree
	jclr	#m_tdre,x:m_ssr,_waitSCIFree	; wait for port free
	move	a,x:m_stxl		; Envoie une commande vers l'A/D
	rts

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

sendssi
	movep	x:(R0)+,x:m_tx
	move	(R6)+
	rti

sendssii				; This should be called just once.
	movep	x:m_sr,x:sink		; clear error and fall through
_fsclear
	jclr	#2,x:m_sr,_fsclear	; check for Transt Frame Sync bit CLEAR
	move	#>$00,a
	move	a,x:m_tx
	rti

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

sciset
	move 	#>$38,a		; Select analog input
	jsr	sendsci		; Envoie une commande vers l'A/D	
	btst 	#3,x:stereo
	jcs 	_sciset_high

	move 	#>$59,a		;#>$59 pour 44.1, #>$5a pour 48
	jsr	sendsci		; Envoie une commande vers l'A/D
	move 	#>$28,a	
	jsr	sendsci		; Envoie une commande vers l'A/D
	move 	#>$68,a	
	jsr	sendsci		; Envoie une commande vers l'A/D
	move 	#>$a4,a	
	jsr	sendsci		; Envoie une commande vers l'A/D
	move 	#>$a0,a	
	jsr	sendsci		; Envoie une commande vers l'A/D
	move 	#>$a1,a	
	jsr	sendsci		; Envoie une commande vers l'A/D
	move 	#>$a0,a	
	jsr	sendsci		; Envoie une commande vers l'A/D
	move 	#>$a0,a	
	jsr	sendsci		; Envoie une commande vers l'A/D
	move 	#>$a0,a	
	jsr	sendsci		; Envoie une commande vers l'A/D
	move 	#>$a0,a		;#>$a0 pour 44.1, #>$a2 pour 48
	jsr	sendsci		; Envoie une commande vers l'A/D
	move 	#>$a0,a	
	jsr	sendsci		; Envoie une commande vers l'A/D
	move 	#>$69,a	
	jsr	sendsci		; Envoie une commande vers l'A/D
	rts
	
_sciset_high
	move 	#>$5a,a		;#>$59 pour 44.1, #>$5a pour 48
	jsr	sendsci		; Envoie une commande vers l'A/D
	move 	#>$28,a	
	jsr	sendsci		; Envoie une commande vers l'A/D
	move 	#>$68,a	
	jsr	sendsci		; Envoie une commande vers l'A/D
	move 	#>$a4,a	
	jsr	sendsci		; Envoie une commande vers l'A/D
	move 	#>$a0,a	
	jsr	sendsci		; Envoie une commande vers l'A/D
	move 	#>$a1,a	
	jsr	sendsci		; Envoie une commande vers l'A/D
	move 	#>$a0,a	
	jsr	sendsci		; Envoie une commande vers l'A/D
	move 	#>$a0,a	
	jsr	sendsci		; Envoie une commande vers l'A/D
	move 	#>$a0,a	
	jsr	sendsci		; Envoie une commande vers l'A/D
	move 	#>$a2,a		;#>$a0 pour 44.1, #>$a2 pour 48
	jsr	sendsci		; Envoie une commande vers l'A/D
	move 	#>$a0,a	
	jsr	sendsci		; Envoie une commande vers l'A/D
	move 	#>$69,a	
	jsr	sendsci		; Envoie une commande vers l'A/D
	rts
